aboutsummaryrefslogtreecommitdiffhomepage
path: root/combine_distfiles_to_tar.sh
diff options
context:
space:
mode:
authorGravatar László Csomor <laszlocsomor@google.com>2017-08-11 10:28:36 +0200
committerGravatar Marcel Hlopko <hlopko@google.com>2017-08-11 12:56:56 +0200
commit0783b9e81328729353cfad7ec25391c03d7f772a (patch)
tree8c68cb2697f13359847814b1e4ecf8708ead37ea /combine_distfiles_to_tar.sh
parent5f99fdab1485186292068d274411201e4fb9208f (diff)
Rewrite //:combine_distfiles.sh in Python
It can only pack to zip for now (packing to tar is not trivial and I haven't figured it out yet). This allows building //:bazel-distfile on Windows. Previously it was either timing out or taking so long that it was unbearable (over 10 minutes). I never waited long enough to see it build. The new Python version runs under just a few seconds. Change-Id: I3264eb7132dd58c581c4216e5bbab035a79d716d PiperOrigin-RevId: 164954162
Diffstat (limited to 'combine_distfiles_to_tar.sh')
-rwxr-xr-xcombine_distfiles_to_tar.sh44
1 files changed, 44 insertions, 0 deletions
diff --git a/combine_distfiles_to_tar.sh b/combine_distfiles_to_tar.sh
new file mode 100755
index 0000000000..40a8f4a336
--- /dev/null
+++ b/combine_distfiles_to_tar.sh
@@ -0,0 +1,44 @@
+#!/bin/sh
+
+# Copyright 2016 The Bazel Authors. All rights reserved.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+set -eu
+
+# Combine the archives passed to a single archive.
+# NOTE: This assumes that the individual archives are already packed
+# in a way to contain canonical timestamps. This assumption must be
+# met in order to obtain reproducible output; the assumption is met
+# for the source tree and the archive of the generated java files.
+
+OUTPUT="${PWD}/$1"
+shift
+
+TMP_DIR=${TMPDIR:-/tmp}
+PACKAGE_DIR="$(mktemp -d ${TMP_DIR%%/}/bazel.XXXXXXXX)"
+trap "rm -fr \"${PACKAGE_DIR}\"" EXIT
+mkdir -p "${PACKAGE_DIR}"
+
+for i in $*
+do
+ ARCHIVE="${PWD}/$i"
+ case "$i" in
+ *.zip) UNPACK="unzip -q" ;;
+ *.tar) UNPACK="tar xf" ;;
+ esac
+ (cd "${PACKAGE_DIR}" && ${UNPACK} "${ARCHIVE}")
+done
+
+(cd "${PACKAGE_DIR}" && tar -c -f "${OUTPUT}" --group=0 --owner=0 \
+ $(find . -type f | sort))